﻿Imports System.Collections
Imports System.Threading
Imports Opto22.Controller

Module Module1

    Dim sControllerIpAddress As String = "172.22.60.3"
    Dim i32ControllerPort As Int32 = 22001
    Dim i32InitialTimeoutMs As Int32 = 1000

    Sub Main()
        ' access controller properties
        MiscellaneousControllerValues()

        ' access controller variables and tables via simple read methods
        ControllerVariables()

        ' access controller objects using the most efficient method available
        GroupedAccessDemo()

    End Sub

    Sub MiscellaneousControllerValues()
        ' controller definition
        Dim Controller As Opto22.Controller.Controller = New Opto22.Controller.Controller()

        ' code generated test values to write to the controller
        Dim i32TestValue As Int32 = Int32.MinValue
        Dim i64TestValue As Int64 = Int64.MinValue
        Dim f32TestValue As Single = 0.0F
        Dim sValue As String
        Dim i32aryTestValues() As Int32 = New Int32(100) {}
        Dim i64aryTestValues() As Int64 = New Int64(100) {}
        Dim f32aryTestValues() As Single = New Single(100) {}
        Dim saryTestValues() As String = New String(100) {}

        ' objects read from the PAC controller
        Dim i32 As Int32
        Dim i64 As Int64
        Dim f32 As Single
        Dim f32Ut As Single
        Dim f32Dt As Single
        Dim s As Single
        Dim i32ary As Int32() = New Int32(1) {}
        Dim i64ary As Int64() = New Int64(1) {}
        Dim f32ary As Single() = New Single(1) {}
        Dim sary As String() = New String(1) {}

        ' open a session to the controller
        Dim eMethodResponse As Controller.ErrorResponse
        eMethodResponse = Controller.OpenSession(sControllerIpAddress, i32ControllerPort, i32InitialTimeoutMs)
        ' validate the attempt
        If (eMethodResponse <> Controller.ErrorResponse.Success) Then
            Console.WriteLine("OpenSession() Failed")
            Return
        End If

        ' loop to repeat reads and writes
        Dim i32LoopCounter As Int32 = 0
        While (i32LoopCounter < 100)
            i32TestValue += 1
            i64TestValue += 1
            f32TestValue += 1.0F
            sValue = i64TestValue.ToString()

            Dim i32Loop As Int32 = 0
            While (i32Loop < i32aryTestValues.Length)
                i32aryTestValues(i32Loop) = i32TestValue + i32Loop
                i32Loop += 1
            End While

            i32Loop = 0
            While (i32Loop < i64aryTestValues.Length)
                i64aryTestValues(i32Loop) = i64TestValue + i32Loop
                i32Loop += 1
            End While

            i32Loop = 0
            While (i32Loop < f32aryTestValues.Length)
                f32aryTestValues(i32Loop) = f32TestValue + i32Loop
                i32Loop += 1
            End While

            i32Loop = 0
            While (i32Loop < saryTestValues.Length)
                saryTestValues(i32Loop) = (f32TestValue + (i32Loop * 10)).ToString()
                i32Loop += 1
            End While

            ' write variables
            eMethodResponse = Controller.Write32BitIntegerVariable("i32", False, i32TestValue)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write i32 returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.Write32BitFloatVariable("f32", False, f32TestValue)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write f32 returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.Write64BitIntegerVariable("i64", False, i64TestValue)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write i64 returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.WriteStringVariable("s", False, sValue)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write s returned {0}.", eMethodResponse)
                Return
            End If

            ' write tables
            eMethodResponse = Controller.Write32BitIntegerTable("i32t", False, i32aryTestValues, 0, i32aryTestValues.Length)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write i32t returned {0}.", eMethodResponse)
            End If

            eMethodResponse = Controller.Write32BitFloatTable("f32t", False, f32aryTestValues, 0, f32aryTestValues.Length)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write f32t returned {0}.", eMethodResponse)
            End If
            eMethodResponse = Controller.Write64BitIntegerTable("i64t", False, i64aryTestValues, 0, i64aryTestValues.Length)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write i64t returned {0}.", eMethodResponse)
            End If

            eMethodResponse = Controller.WriteStringTable("st", False, saryTestValues, 0, saryTestValues.Length)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Write st returned {0}.", eMethodResponse)
            End If

            ' read the values back
            eMethodResponse = Controller.Read32BitIntegerVariable("i32", False, i32)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read i32 returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.Read64BitIntegerVariable("i64", False, i64)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read i64 returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.Read32BitFloatVariable("f32", False, f32)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read f32 returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.ReadUpTimerVariable("ut", False, f32Ut)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read ut returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.ReadDownTimerVariable("dt", False, f32Dt)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read dt returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.ReadStringVariable("s", False, s)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read s returned {0}.", eMethodResponse)
                Return
            End If

            eMethodResponse = Controller.Read32BitIntegerTable("i32t", False, 0, i32aryTestValues.Length, i32ary)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read i32t returned {0}.", eMethodResponse)
                Return
            End If
            eMethodResponse = Controller.Read64BitIntegerTable("i64t", False, 0, f32aryTestValues.Length, i64ary)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read i64t returned {0}.", eMethodResponse)
                Return
            End If
            eMethodResponse = Controller.Read32BitFloatTable("f32t", False, 0, i64aryTestValues.Length, f32ary)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read f32t returned {0}.", eMethodResponse)
                Return
            End If
            eMethodResponse = Controller.ReadStringTable("st", False, 0, saryTestValues.Length, sary)
            If (eMethodResponse <> Controller.ErrorResponse.Success) Then
                Console.WriteLine("Read st returned {0}.", eMethodResponse)
                Return
            End If

            ' validate read values
            If (i32TestValue <> i32) Then
                Console.WriteLine("Mismatch Reading 32-bit Integer Variable")
                Return
            End If
            If (i64TestValue <> i64) Then
                Console.WriteLine("Mismatch Reading 64-bit Integer Variable")
                Return
            End If
            If (f32TestValue <> f32) Then
                Console.WriteLine("Mismatch Reading 32-bit Float Variable")
                Return
            End If
            If (sValue <> s) Then
                Console.WriteLine("Mismatch Reading String Variable")
                Return
            End If

            i32Loop = 0
            While (i32Loop < i32aryTestValues.Length)
                If (i32ary Is Nothing) Or (i32aryTestValues(i32Loop) <> i32ary(i32Loop)) Then
                    Console.WriteLine("Mismatch Reading 32-bit Integer Table Index {0}", i32Loop)
                    Return
                End If
                i32Loop += 1
            End While
            i32Loop = 0
            While (i32Loop < i32aryTestValues.Length)
                If (i64ary Is Nothing) Or (i64aryTestValues(i32Loop) <> i64ary(i32Loop)) Then
                    Console.WriteLine("Mismatch Reading 64-bit Integer Table Index {0}", i32Loop)
                    Return
                End If
                i32Loop += 1
            End While
            i32Loop = 0
            While (i32Loop < i32aryTestValues.Length)
                If (f32ary Is Nothing) Or (f32aryTestValues(i32Loop) <> f32ary(i32Loop)) Then
                    Console.WriteLine("Mismatch Reading 32-bit Float Table Index {0}", i32Loop)
                    Return
                End If
                i32Loop += 1
            End While
            i32Loop = 0
            While (i32Loop < i32aryTestValues.Length)
                If (sary Is Nothing) Or (saryTestValues(i32Loop) <> sary(i32Loop)) Then
                    Console.WriteLine("Mismatch Reading String Table Index {0}", i32Loop)
                    Return
                End If
                i32Loop += 1
            End While

            i32ary = Nothing
            i64ary = Nothing
            f32ary = Nothing
            sary = Nothing

            ' print activity when read values validate
            Console.WriteLine("ControllerVariables() finished scan {0}", i32LoopCounter)

            Console.WriteLine("controller.MessageLogCount reports {0} messages.", Controller.MessageLogCount)
            While (Controller.MessageLogCount > 0)
                Dim sLoggedMessage As String = ""
                Controller.PopMessageLogged(sLoggedMessage)
                Console.WriteLine("  {0}", sLoggedMessage)
            End While

            ' throttle the loop's scan rate
            Thread.Sleep(250)
            i32LoopCounter += 1
        End While

        ' close the connection to the controller, make sure to dispose of the connection
        ' the session should only be closed when the application is complete finished using
        ' the session or a communication fault is encountered
        Controller.CloseSession()
        Controller.Dispose()
        Controller = Nothing

    End Sub

    Sub ControllerVariables()
        Dim controller As Opto22.Controller.Controller = New Controller()
        Dim eMethodResponse As Controller.ErrorResponse = controller.OpenSession(sControllerIpAddress, i32ControllerPort, i32InitialTimeoutMs)
        If (eMethodResponse <> Controller.ErrorResponse.Success) Then
            Console.WriteLine("OpenSession failed.")
            Return
        End If

        ' test integer "out" based reads
        Dim i32AutoRunStatus As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.autorunstatus, i32AutoRunStatus)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read autorunstatus returned {0}.", i32AutoRunStatus)
        End If

        Dim i32ChartsRunning As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.chartsrunningcount, i32ChartsRunning)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read chartsrunningcount returned {0}.", i32ChartsRunning)
        End If

        Dim i32FileMemory As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.filememory, i32FileMemory)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read filememory returned {0}.", i32FileMemory)
        End If

        Dim sFirmwareVersion As String = ""
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.firmwareversion, sFirmwareVersion)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read firmwareversion returned {0}.", sFirmwareVersion)
        End If

        Dim i32MessageQueueCount As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.getmessagequeuecount, i32MessageQueueCount)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read getmessagequeuecount returned {0}.", i32MessageQueueCount)
        End If

        Dim i32StackDepth As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.stackdepth, i32StackDepth)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read stackdepth returned {0}.", i32StackDepth)
        End If

        Dim i32NonVolatileMemory As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.nonvolatilememory, i32NonVolatileMemory)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read nonvolatilememory returned {0}.", i32NonVolatileMemory)
        End If

        Dim i32VolatileMemory As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.volatilememory, i32VolatileMemory)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read volatilememory returned {0}.", i32VolatileMemory)
        End If

        Dim i32UpTimeSeconds As Int32 = 0
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.uptimeseconds, i32UpTimeSeconds)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read uptimeseconds returned {0}.", i32UpTimeSeconds)
        End If

        ' test string "out" based item reads
        Dim sPartNumber As String = ""
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.partnumber, sPartNumber)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read partnumber returned {0}.", sPartNumber)
        End If

        Dim sStrategyDateStamp As String = ""
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.strategydatestamp, sStrategyDateStamp)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read strategydatestamp returned {0}.", sStrategyDateStamp)
        End If

        Dim sStrategyName As String = ""
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.strategyname, sStrategyName)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read strategyname returned {0}.", sStrategyName)
        End If

        Dim sStrategyTimeStamp As String = ""
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.strategytimestamp, sStrategyTimeStamp)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read strategytimestamp returned {0}.", sStrategyTimeStamp)
        End If

        Dim sTimeDate As String = ""
        eMethodResponse = controller.ReadItem(controller.Item.eItemTypes.timedate, sTimeDate)
        If (eMethodResponse = Controller.ErrorResponse.Success) Then
            Console.WriteLine("Read timedate returned {0}.", sTimeDate)
        End If

        Console.WriteLine("MiscellaneousControllerValues() finished")
        controller.CloseSession()
        controller.Dispose()
        controller = Nothing
    End Sub

    Sub GroupedAccessDemo()
        Dim controller As Opto22.Controller.Controller = New Controller()
        Dim eMethodResponse As Controller.ErrorResponse = controller.OpenSession(sControllerIpAddress, i32ControllerPort, i32InitialTimeoutMs)
        If (eMethodResponse <> Controller.ErrorResponse.Success) Then
            Console.WriteLine("OpenSession failed.")
            Return
        End If

        Dim i32LoopCounter As Int32 = 0
        While (i32LoopCounter < 100)
            Const i32ItemLimit As Int32 = 40
            Dim aryGroupItems As Controller.Item() = controller.NewItemList(i32ItemLimit)
            Dim bResult As Boolean
            Dim i32ListIndex As Int32 = 0

            ' analog point grouped read
            Dim earyAnalogAllAttributes(2) As Controller.Item.eAnalogPointAttributes
            earyAnalogAllAttributes(0) = controller.Item.eAnalogPointAttributes.eu
            earyAnalogAllAttributes(1) = controller.Item.eAnalogPointAttributes.maximum

            bResult = aryGroupItems(i32ListIndex).SetAnalogRead("ai", controller.Item.eItemTypes.apoint, earyAnalogAllAttributes, earyAnalogAllAttributes.Length)
            i32ListIndex += 1

            Dim earyDiscreteAllAttributes(3) As Controller.Item.eDiscretePointAttributes
            earyDiscreteAllAttributes(0) = controller.Item.eDiscretePointAttributes.state
            earyDiscreteAllAttributes(1) = controller.Item.eDiscretePointAttributes.onlatch
            earyDiscreteAllAttributes(2) = controller.Item.eDiscretePointAttributes.offlatch

            bResult = aryGroupItems(i32ListIndex).SetDiscreteRead("di", controller.Item.eItemTypes.dpoint, earyDiscreteAllAttributes, earyDiscreteAllAttributes.Length)
            i32ListIndex += 1

            Dim earyPidAllAttributes(7) As Controller.Item.ePidAttributes
            earyPidAllAttributes(0) = controller.Item.ePidAttributes.automanual
            earyPidAllAttributes(1) = controller.Item.ePidAttributes.gain
            earyPidAllAttributes(2) = controller.Item.ePidAttributes.integral
            earyPidAllAttributes(3) = controller.Item.ePidAttributes.derivative
            earyPidAllAttributes(4) = controller.Item.ePidAttributes.input
            earyPidAllAttributes(5) = controller.Item.ePidAttributes.output
            earyPidAllAttributes(6) = controller.Item.ePidAttributes.scanrate

            bResult = aryGroupItems(i32ListIndex).SetPidRead("pid", controller.Item.eItemTypes.pid, earyPidAllAttributes, earyPidAllAttributes.Length)
            i32ListIndex += 1

            bResult = aryGroupItems(i32ListIndex).SetRead("i32", controller.Item.eItemTypes.integer32)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("i64", controller.Item.eItemTypes.integer64)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("f32", controller.Item.eItemTypes.float32)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("ut", controller.Item.eItemTypes.uptimer)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("s", controller.Item.eItemTypes.stringvariable)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("i32t", controller.Item.eItemTypes.integer32table, 0, 50)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("i64t", controller.Item.eItemTypes.integer64table, 0, 10)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("f32t", controller.Item.eItemTypes.float32table, 0, 5)
            i32ListIndex += 1
            bResult = aryGroupItems(i32ListIndex).SetRead("st", controller.Item.eItemTypes.stringtable, 0, 11)
            i32ListIndex += 1

            ' access the items configured in aryGroupItems, all at once
            eMethodResponse = controller.ReadGroupItems(aryGroupItems, 0, i32ListIndex)
            i32ListIndex = 0

            ' test if ReadGroupItems suceeded.
            If (eMethodResponse = controller.ErrorResponse.Success) Then
                Dim bGetDataResult As Boolean
                If (aryGroupItems(i32ListIndex).SuccessfulRead = True) Then
                    ' process item
                    Dim f32AnalogEu As Single
                    Dim f32AnalogMax As Single
                    bGetDataResult = aryGroupItems(i32ListIndex).GetAnalogData(controller.Item.eAnalogPointAttributes.eu, f32AnalogEu)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("Analog Point eu {0}", f32AnalogEu)
                    End If

                    bGetDataResult = aryGroupItems(i32ListIndex).GetAnalogData(controller.Item.eAnalogPointAttributes.maximum, f32AnalogMax)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("Analog Point maximum {0}", f32AnalogMax)
                    End If
                End If
                i32ListIndex += 1

                If (aryGroupItems(i32ListIndex).SuccessfulRead = True) Then
                    Dim bState As Boolean
                    Dim bOnLatch As Boolean
                    Dim bOffLatch As Boolean
                    bGetDataResult = aryGroupItems(i32ListIndex).GetDiscreteData(controller.Item.eDiscretePointAttributes.state, bState)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("Discrete state {0}", bState)
                    End If

                    bGetDataResult = aryGroupItems(i32ListIndex).GetDiscreteData(controller.Item.eDiscretePointAttributes.onlatch, bOnLatch)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("Discrete on-latch {0}", bOnLatch)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetDiscreteData(controller.Item.eDiscretePointAttributes.offlatch, bOffLatch)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("Discrete off-latch {0}", bOffLatch)
                    End If
                End If
                i32ListIndex += 1

                If (aryGroupItems(i32ListIndex).SuccessfulRead = True) Then
                    Dim bIsAutomatic As Boolean
                    Dim f32GainCoefficient As Single
                    Dim f32Integral As Single
                    Dim f32Derivative As Single
                    Dim f32Input As Single
                    Dim f32Output As Single
                    Dim f32Scanrate As Single

                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.automanual, bIsAutomatic)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PID in automatic mode {0}", bIsAutomatic)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.gain, f32GainCoefficient)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PID Gain {0}", f32GainCoefficient)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.integral, f32Integral)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PID Integral {0}", f32Integral)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.derivative, f32Derivative)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PID Derivative {0}", f32Derivative)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.input, f32Input)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PID Input {0}", f32Input)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.output, f32Output)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PIDput {0}", f32Output)
                    End If
                    bGetDataResult = aryGroupItems(i32ListIndex).GetPidData(controller.Item.ePidAttributes.scanrate, f32Scanrate)
                    If (bGetDataResult = True) Then
                        Console.WriteLine("PID Scan Rate {0}", f32Scanrate)
                    End If
                End If
                i32ListIndex += 1

                Dim i32 As Int32
                Dim i64 As Int64
                Dim f32 As Single
                Dim f32ut As Single
                Dim s As String = ""
                Dim i32ary() As Int32
                Dim i64ary() As Int64
                Dim f32ary() As Single
                Dim sary() As String

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(i32)
                If (bGetDataResult = True) Then
                    Console.WriteLine("i32 {0}", i32)
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(i64)
                If (bGetDataResult = True) Then
                    Console.WriteLine("i64 {0}", i64)
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(f32)
                If (bGetDataResult = True) Then
                    Console.WriteLine("f32 {0}", f32)
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(f32ut)
                If (bGetDataResult = True) Then
                    Console.WriteLine("f32ut {0}", f32ut)
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(s)
                If (bGetDataResult = True) Then
                    Console.WriteLine("s {0}", s)
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(i32ary)
                If (bGetDataResult = True) Then
                    Console.WriteLine("i32ary read successful")
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(i64ary)
                If (bGetDataResult = True) Then
                    Console.WriteLine("i64ary read successful")
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(f32ary)
                If (bGetDataResult = True) Then
                    Console.WriteLine("f32ary read successful")
                End If
                i32ListIndex += 1

                bGetDataResult = aryGroupItems(i32ListIndex).GetData(sary)
                If (bGetDataResult = True) Then
                    Console.WriteLine("sary read successful")
                End If
                i32ListIndex += 1

                Thread.Sleep(0)
            End If
            ' throttle the scan rate
            Console.WriteLine("GroupedAccessDemo() finished scan {0}", i32LoopCounter)
            Thread.Sleep(250)
            i32LoopCounter += 1
        End While

        Console.WriteLine("GroupedAccessDemo() Finished")
        controller.CloseSession()
        controller.Dispose()
        controller = Nothing

    End Sub
End Module
